﻿using System;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Security.Principal;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Web.Http;

namespace BasicAuthentication.Controller
{
    public class BasicAuthenticationHandler : DelegatingHandler
    {
        protected override Task<HttpResponseMessage> SendAsync(
            HttpRequestMessage request,
            CancellationToken cancellationToken)
        {
            var response = Authentication(request);

            if (response != null)
            {
                return Task<HttpResponseMessage>.Factory.StartNew(() => response);
            }
            else
            {
                return base.SendAsync(request, cancellationToken);
            }
        }

        private HttpResponseMessage Authentication(HttpRequestMessage request)
        {
            var auth = request.Headers.Authorization;
            if (auth != null)
            {
                if (auth.Scheme == "Basic")
                {
                    var encoder = Encoding.GetEncoding("iso-8859-1");
                    var raw = encoder.GetString(Convert.FromBase64String(auth.Parameter));
                    var splited = raw.Split(new char[] { ':' });
                    var username = splited[0];
                    var password = splited[1];

                    if (password == "correct")
                    {
                        var u2 = username.Split(new char[] { '-' });
                        var identity = new GenericIdentity(u2[0]);
                        string[] roles;
                        if (u2.Length > 1)
                        {
                            roles = new string[] { u2[1] };
                        }
                        else
                        {
                            roles = new string[] { };
                        }

                        var principal = new GenericPrincipal(identity, roles);
                        Thread.CurrentPrincipal = principal;

                        return null;
                    }
                }
            }

            var retval = request.CreateErrorResponse(HttpStatusCode.Unauthorized, string.Empty);
            retval.Headers.WwwAuthenticate.Add(new AuthenticationHeaderValue("Basic"));

            return retval;
        }
    }
}