﻿using System.Linq;
using System.Net.Http;
using System.Web.Http;

namespace BasicAuthentication.Controller
{
    public class ValueController : ApiController
    {
        public string[] Get()
        {
            return Enumerable.Range(0, 10).Select(i => i.ToString()).ToArray();
        }

        [Authorize(Users="troy")]
        public string[] Get(int start)
        {
            return Enumerable.Range(start, 10).Select(i => i.ToString()).ToArray();
        }

        [Authorize(Users="poweruser")]
        public string[] Get(int start, int count)
        {
            if (count <= 0)
            {
                var response = this.Request.CreateErrorResponse(
                    System.Net.HttpStatusCode.BadRequest,
                    "count must larger than zero");

                throw new HttpResponseException(response);
            }

            return Enumerable.Range(start, count).Select(i => i.ToString()).ToArray();
        }
    }
}